"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Validator = require("async-validator");
exports.validate = (scheme, options = {
        checkRequire: true,
    }) => (values) => __awaiter(this, void 0, void 0, function* () {
    const testScheme = options && options.checkRequire
        ? scheme
        : ignoreRequire(scheme);
    return new Promise((resolve, reject) => {
        try {
            new Validator(testScheme).validate(values, resolve);
        }
        catch (e) {
            reject(e);
        }
    });
});
function ignoreRequire(scheme) {
    return Object.keys(scheme).reduce((collection, key) => (Object.assign({}, collection, { [key]: scheme[key].map((rule) => (Object.assign({}, rule, { required: false }))) })), {});
}
